<template>
    <div>
        <base-dialog :show="!!error" title="An error occurred" @close="handleError">
            <p>{{ error }}</p>
        </base-dialog>
        <base-dialog :show="isLoading" fixed title="Authenticating...">
            <base-spinner></base-spinner>
        </base-dialog>
        <base-card>
            <h4>email: test@localhost.com</h4>
            <h4>password: secret</h4>
            <form @submit.prevent="submitForm">
                <div class="form-control">
                    <label for="email">E-Mail</label>
                    <input id="email" v-model.trim="email" type="email"/>
                </div>
                <div class="form-control">
                    <label for="password">Password</label>
                    <input id="password" v-model.trim="password" type="password"/>
                </div>
                <p
                    v-if="!formIsValid"
                >Please enter a valid email and password (must be at least 6 characters long).</p>
                <base-button>login</base-button>
              <base-button link to="/auth/register">Register</base-button>
            </form>
        </base-card>
    </div>
</template>

<script>
export default {
    data() {
        return {
            email: '',
            password: '',
            formIsValid: true,
            isLoading: false,
            error: null,
        };
    },
    methods: {
        async submitForm() {
            this.formIsValid = true;
            if (
                this.email === '' ||
                !this.email.includes('@') ||
                this.password.length < 6
            ) {
                this.formIsValid = false;
                return;
            }

            this.isLoading = true;

            const actionPayload = {
                email: this.email,
                password: this.password,
            };

            try {
                await this.$store.dispatch('login', actionPayload);
                const redirectUrl = '/articles';
                this.$router.replace(redirectUrl);
            } catch (err) {
                this.error = err.message || 'Failed to authenticate, try later.';
            }

            this.isLoading = false;
        },
        handleError() {
            this.error = null;
        },
    },
};
</script>

<style scoped>
form {
    margin: 1rem;
    padding: 1rem;
}

.form-control {
    margin: 0.5rem 0;
}

label {
    font-weight: bold;
    margin-bottom: 0.5rem;
    display: block;
}

input,
textarea {
    display: block;
    width: 100%;
    font: inherit;
    border: 1px solid #ccc;
    padding: 0.15rem;
}

input:focus,
textarea:focus {
    border-color: #3d008d;
    background-color: #faf6ff;
    outline: none;
}
</style>
